'''
The file-buffer for data transfer
'''

from os import path, remove
from converter import to_hex31_127hex_escape_as_symbol, to_hex31_127hex_escape_as_char

class Buffer(object):
    def __init__(self, path, name='buffer'):
        self.filename = path + name
        self.file = None

    def check(self):
        try:
            return path.isfile(self.filename)
        except:
            return False

    def write(self, text='', printingsymbolsmode=0):
        try:
            self.file = open(self.filename, 'a')
            if printingsymbolsmode == 1:
                self.file.write(to_hex31_127hex_escape_as_symbol(text))
            elif printingsymbolsmode == 2:
                self.file.write(to_hex31_127hex_escape_as_char(text))
            else:
                self.file.write(text)
            self.file.close()
            self.file = None
        except:
            return False
        return True    

    def read(self, clear=True):
        try:
            try:
                self.file = open(self.filename, 'r')
                try:
                    return self.file.read()
                finally:
                    self.file.close()
                    self.file = None
            finally:
                if clear:
                    self.clear()    
        except:
            return ''
    
    def clear(self):
        try:
            remove(self.filename)
        except:
            return False
        return True